Index: EDIS/trunk/java/tracking-server-main/src/main/webapp/WEB-INF/web.xml
===================================================================
--- EDIS/trunk/java/tracking-server-main/src/main/webapp/WEB-INF/web.xml	(revision 1227)
+++ EDIS/trunk/java/tracking-server-main/src/main/webapp/WEB-INF/web.xml	(revision 1252)
@@ -18,8 +18,11 @@
     <context-param>
         <param-name>contextConfigLocation</param-name>
-        <param-value>
-            classpath*:/applicationContext-dao.xml
-        </param-value>
+        <param-value>/WEB-INF/config/web-application-config.xml</param-value>
     </context-param>
+
+    <filter>
+        <filter-name>springSecurityFilterChain</filter-name>
+        <filter-class>org.springframework.web.filter.DelegatingFilterProxy</filter-class>
+    </filter>
 
     <filter>
@@ -35,5 +38,5 @@
         <filter-name>noCacheFilter</filter-name>
         <filter-class>gov.va.med.edp.web.servlet.filter.ResponseHeaderFilter</filter-class>
-         <init-param>
+        <init-param>
             <param-name>Cache-Control</param-name>
             <param-value>no-store, must-revalidate</param-value>
@@ -45,48 +48,8 @@
     </filter>
 
-    <listener>
-        <listener-class>org.springframework.web.util.IntrospectorCleanupListener</listener-class>
-    </listener>
-
-    <listener>
-        <listener-class>org.springframework.web.context.ContextLoaderListener</listener-class>
-    </listener>
-
-    <listener>
-        <listener-class>gov.va.med.authentication.kernel.KaajeeSessionAttributeListener</listener-class>
-    </listener>
-
-    <listener>
-        <listener-class>gov.va.med.authentication.kernel.KaajeeHttpSessionListener</listener-class>
-    </listener>
-
-    <listener>
-        <listener-class>gov.va.med.edp.web.servlet.listener.TimeOutIntegrationSessionAttributeListener</listener-class>
-    </listener>
-
-    <servlet>
-        <servlet-name>KaajeeInit</servlet-name>
-        <servlet-class>gov.va.med.authentication.kernel.InitKaajeeServlet</servlet-class>
-        <init-param>
-            <param-name>kaajee-config-file-location</param-name>
-            <param-value>/WEB-INF/kaajeeConfig.xml</param-value>
-        </init-param>
-        <load-on-startup>3</load-on-startup>
-    </servlet>
-
-    <servlet>
-        <servlet-name>LoginController</servlet-name>
-        <servlet-class>gov.va.med.authentication.kernel.LoginController</servlet-class>
-        <run-as>
-            <!-- In this example, weblogic is the boot user name (i.e., weblogic console user name) -->
-            <role-name>weblogic</role-name>
-        </run-as>
-    </servlet>
-
-    <servlet>
-        <servlet-name>dispatcher</servlet-name>
-        <servlet-class>org.springframework.web.servlet.DispatcherServlet</servlet-class>
-        <load-on-startup>1</load-on-startup>
-    </servlet>
+    <filter-mapping>
+        <filter-name>springSecurityFilterChain</filter-name>
+        <url-pattern>/*</url-pattern>
+    </filter-mapping>
 
     <filter-mapping>
@@ -105,5 +68,5 @@
     </filter-mapping>
 
-     <filter-mapping>
+    <filter-mapping>
         <filter-name>noCacheFilter</filter-name>
         <url-pattern>/board.html</url-pattern>
@@ -115,8 +78,25 @@
     </filter-mapping>
 
-    <servlet-mapping>
-        <servlet-name>LoginController</servlet-name>
-        <url-pattern>/LoginController</url-pattern>
-    </servlet-mapping>
+    <listener>
+        <listener-class>org.springframework.web.util.IntrospectorCleanupListener</listener-class>
+    </listener>
+
+    <listener>
+        <listener-class>org.springframework.web.context.ContextLoaderListener</listener-class>
+    </listener>
+
+    <listener>
+        <listener-class>org.springframework.security.ui.session.HttpSessionEventPublisher</listener-class>
+    </listener>
+
+    <listener>
+        <listener-class>gov.va.med.edp.web.servlet.listener.TimeOutIntegrationSessionAttributeListener</listener-class>
+    </listener>
+
+    <servlet>
+        <servlet-name>dispatcher</servlet-name>
+        <servlet-class>org.springframework.web.servlet.DispatcherServlet</servlet-class>
+        <load-on-startup>1</load-on-startup>
+    </servlet>
 
     <servlet-mapping>
@@ -132,15 +112,5 @@
     <servlet-mapping>
         <servlet-name>dispatcher</servlet-name>
-        <url-pattern>tracking.html</url-pattern>
-    </servlet-mapping>
-
-    <servlet-mapping>
-        <servlet-name>dispatcher</servlet-name>
-        <url-pattern>board.html</url-pattern>
-    </servlet-mapping>
-
-    <servlet-mapping>
-        <servlet-name>dispatcher</servlet-name>
-        <url-pattern>logout.html</url-pattern>
+        <url-pattern>*.html</url-pattern>
     </servlet-mapping>
 
@@ -158,59 +128,59 @@
     </error-page>
 
-    <security-constraint>
-        <web-resource-collection>
-            <web-resource-name>ED Tracking Board XML Services</web-resource-name>
-            <url-pattern>*.xml</url-pattern>
-            <http-method>GET</http-method>
-            <http-method>POST</http-method>
-        </web-resource-collection>
-        <auth-constraint>
-            <role-name>AUTHENTICATED_KAAJEE_USER</role-name>
-        </auth-constraint>
-        <user-data-constraint>
-            <transport-guarantee>NONE</transport-guarantee>
-        </user-data-constraint>
-    </security-constraint>
+    <!--<security-constraint>-->
+    <!--<web-resource-collection>-->
+    <!--<web-resource-name>ED Tracking Board XML Services</web-resource-name>-->
+    <!--<url-pattern>*.xml</url-pattern>-->
+    <!--<http-method>GET</http-method>-->
+    <!--<http-method>POST</http-method>-->
+    <!--</web-resource-collection>-->
+    <!--<auth-constraint>-->
+    <!--<role-name>AUTHENTICATED_KAAJEE_USER</role-name>-->
+    <!--</auth-constraint>-->
+    <!--<user-data-constraint>-->
+    <!--<transport-guarantee>NONE</transport-guarantee>-->
+    <!--</user-data-constraint>-->
+    <!--</security-constraint>-->
 
-    <security-constraint>
-        <web-resource-collection>
-            <web-resource-name>ED Tracking Board Flex Client</web-resource-name>
-            <url-pattern>*.swf</url-pattern>
-            <url-pattern>tracking.html</url-pattern>
-            <url-pattern>board.html</url-pattern>
-            <http-method>GET</http-method>
-        </web-resource-collection>
-        <auth-constraint>
-            <role-name>AUTHENTICATED_KAAJEE_USER</role-name>
-        </auth-constraint>
-        <user-data-constraint>
-            <transport-guarantee>NONE</transport-guarantee>
-        </user-data-constraint>
-    </security-constraint>
+    <!--<security-constraint>-->
+    <!--<web-resource-collection>-->
+    <!--<web-resource-name>ED Tracking Board Flex Client</web-resource-name>-->
+    <!--<url-pattern>*.swf</url-pattern>-->
+    <!--<url-pattern>tracking.html</url-pattern>-->
+    <!--<url-pattern>board.html</url-pattern>-->
+    <!--<http-method>GET</http-method>-->
+    <!--</web-resource-collection>-->
+    <!--<auth-constraint>-->
+    <!--<role-name>AUTHENTICATED_KAAJEE_USER</role-name>-->
+    <!--</auth-constraint>-->
+    <!--<user-data-constraint>-->
+    <!--<transport-guarantee>NONE</transport-guarantee>-->
+    <!--</user-data-constraint>-->
+    <!--</security-constraint>-->
 
-    <security-constraint>
-        <web-resource-collection>
-            <web-resource-name>ED Tracking Board Debug Screen</web-resource-name>
-            <url-pattern>debug.jsp</url-pattern>
-            <http-method>GET</http-method>
-        </web-resource-collection>
-        <auth-constraint>
-            <role-name>AUTHENTICATED_KAAJEE_USER</role-name>
-        </auth-constraint>
-        <user-data-constraint>
-            <transport-guarantee>NONE</transport-guarantee>
-        </user-data-constraint>
-    </security-constraint>
+    <!--<security-constraint>-->
+    <!--<web-resource-collection>-->
+    <!--<web-resource-name>ED Tracking Board Debug Screen</web-resource-name>-->
+    <!--<url-pattern>debug.jsp</url-pattern>-->
+    <!--<http-method>GET</http-method>-->
+    <!--</web-resource-collection>-->
+    <!--<auth-constraint>-->
+    <!--<role-name>AUTHENTICATED_KAAJEE_USER</role-name>-->
+    <!--</auth-constraint>-->
+    <!--<user-data-constraint>-->
+    <!--<transport-guarantee>NONE</transport-guarantee>-->
+    <!--</user-data-constraint>-->
+    <!--</security-constraint>-->
 
-    <login-config>
-        <auth-method>FORM</auth-method>
-        <form-login-config>
-            <form-login-page>login/login.jsp</form-login-page>
-            <form-error-page>login/loginerror.jsp</form-error-page>
-        </form-login-config>
-    </login-config>
-    
-    <security-role>
-        <role-name>AUTHENTICATED_KAAJEE_USER</role-name>
-    </security-role>
+    <!--<login-config>-->
+    <!--<auth-method>FORM</auth-method>-->
+    <!--<form-login-config>-->
+    <!--<form-login-page>login/login.jsp</form-login-page>-->
+    <!--<form-error-page>login/loginerror.jsp</form-error-page>-->
+    <!--</form-login-config>-->
+    <!--</login-config>-->
+    <!---->
+    <!--<security-role>-->
+    <!--<role-name>AUTHENTICATED_KAAJEE_USER</role-name>-->
+    <!--</security-role>-->
 </web-app>